/*
AVL Tree package.  Manipulate tree nodes which contain a pointer to an
object of interest.

Objects of interest are compared using a function of type Comparator
which takes two pointers to objects and returns an int.  The int
values are -1, 0, +1, just as for strcmp.  

*/

#include <stdio.h>
#include <stdlib.h>

#include "tree.h"
#include "privatetree.h"
#include "reporter.h"

#ifndef max
#define max(a,b) (((a) > (b)) ? (a) : (b))
#endif

static int GetHeight(SearchTree T);
static Position SingleRotateWithLeft(Position K2);
static Position SingleRotateWithRight(Position K2);
static Position DoubleRotateWithLeft(Position K3);
static Position DoubleRotateWithRight(Position K3);

/* replace "Anonymous Author" with "your name" */

char *getTreeAuthor(void) {
  return "Anonymous Author";
}

/* Your code goes here to implement the AVL tree management routines. */