#ifndef _tree_h
#define _tree_h

#include "element.h"

struct TreeNode;
typedef struct TreeNode *Position;
typedef struct TreeNode *SearchTree;

char *getTreeAuthor(void);

SearchTree CreateTree(void);
SearchTree DestroyTree(SearchTree T);

SearchTree InsertTreeNode(SearchTree T, Comparator C, ElementType X);
Position FindTreeNode(SearchTree T, Comparator C, ElementType X);
Position FindTreeNodeMin(SearchTree T);
Position FindTreeNodeMax(SearchTree T);

ElementType RetrieveTreeNodeElement(Position P);

#endif /* _tree_h */
